## magics++ 4.5.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
find_package( ecbuild 3.4 REQUIRED )

project( magics VERSION 4.5.0 LANGUAGES CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

include(ecbuild_system NO_POLICY_SCOPE)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)

###############################################################################
# some build options for this project


ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo)


string(STRIP "${PANGOCAIRO_LIBRARIES}" PANGOCAIRO_LIBRARIES)
if(PANGOCAIRO_FOUND)
 set(HAVE_CAIRO ON)
  ecbuild_enable_feature( CAIRO )
endif()

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo] -  work on progress"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C" )


ecbuild_add_option( FEATURE ODB
                    DEFAULT OFF
                    DESCRIPTION "ODB support - to be deprecated"
                    REQUIRED_PACKAGES "odc" )

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE EFAS
                    DEFAULT OFF
                    DESCRIPTION "enable EFAS coastlines and catchments" )


set( MAGICS_NAME          "Magics" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )


###############################################################################
### Metview and Qt
ecbuild_info("TESTING for Metview and Qt ...")

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    ecbuild_info("TESTING for Qt5 ...")
    unset(MAGICS_ONLY)

    find_package(Qt5Widgets REQUIRED)
    if( Qt5Widgets_FOUND )
        ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
        include_directories(${Qt5Widgets_INCLUDE_DIRS})
        set( MAGICS_QT 1)
        set( MAGICS_QT5 1)
        set( qt yes)
        add_definitions( -DMAGICS_QT5 )
    else()
        ecbuild_critical("Qt5 was NOT found, but it is necessary if METVIEW is enabled ...")
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

ecbuild_find_package( NAME eccodes VERSION 2.19.0 REQUIRED
                      FAILURE_MSG "ecCodes is required in order to build Magics" )
set( HAVE_GRIB 1 )
set( HAVE_BUFR 1 )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )


if( EC_OS_NAME MATCHES "windows" )
    message("====================== IN WINDOWS")
    find_package( Pthread REQUIRED )
    message("====================== IN WINDOWS ${PTHREAD_INCLUDE_DIR} ${PTHREAD_LIBRARIES}")
    list( APPEND MAGICS_EXTRA_LIBRARIES ${PTHREAD_LIBRARIES} )
else()
  find_package( Threads )
endif()


# adding NO_MODULE means that if we don't find it, CMake will not generate
# strange error messages about not being able to find the FindProj4.cmake file.
# this should find proj if it has been installed via CMake, but if it has been
# installed via autotools, then we will need to try another method
#ecbuild_find_package(NAME PROJ4 VERSION 6.1.0 QUIET )
# find_package( PROJ4 6.1.0 NO_MODULE )
# if(NOT PROJ4_FOUND)
find_package(PROJ 6.1.0 REQUIRED)
if (NOT PROJ_FOUND)
    message(FATAL_ERROR "Package 'proj' was not found - at least version 6.1.0 required.")
endif()

message("PROJ include: ${PROJ_INCLUDE_DIR}")
message("PROJ library: ${PROJ_LIBRARIES}")
list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${PROJ_INCLUDE_DIR})
# endif()


find_package( EXPAT REQUIRED )   # for MagML

if(APPLE)
  find_package( zlib REQUIRED )  # dependency of minizip - KMZ support
endif(APPLE)

###############################################################################
# Windows compiler options

if( EC_OS_NAME MATCHES "windows" )
    # Suppress compliler warnings
    # Suppress warnings about using 'insecure' functions. Fixing this would require changes all over
    # the codebase which would damage portability.
    ecbuild_add_c_flags("/D_CRT_SECURE_NO_WARNINGS")
    ecbuild_add_cxx_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.
    ecbuild_add_c_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    ecbuild_add_cxx_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    # Suppress C4267: warns about possible loss of data when converting 'size_t' to 'int'.
    ecbuild_add_c_flags("/wd4267")
    ecbuild_add_cxx_flags("/wd4267")
    # Suppress C4800: forcing value to bool 'true' or 'false'
    ecbuild_add_cxx_flags("/wd4800")

    # Prevent fatal error C1128
    ecbuild_add_cxx_flags("/bigobj")
endif()

###############################################################################
# contents

if ( HAVE_ODB )
  ecbuild_info("Adding support for ODB")
  list( APPEND MAGICS_EXTRA_LIBRARIES odccore)
endif()



if( HAVE_CAIRO )
  list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS})
endif()

set( MAGICS_LIBRARIES MagPlus )

if( MAGICS_QT )
  list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
  list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )

  if( WITH_QT_DEBUG )
    list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
  endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS	${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES	${GEOTIFF_LIBRARY} )
	list( APPEND MAGICS_EXTRA_DEFINITIONS	HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

if( EC_OS_NAME MATCHES "windows" )
    # We need to link to ws2_32.lib to avoid an unresolved external (gethostname)
    # It's part of the Windows SDK so no need to search for it.
    list( APPEND MAGICS_EXTRA_LIBRARIES ws2_32 )
    # We need to find zlib.lib
    find_library( ZLIB_LIB zlib PATHS ENV PATH )
    list( APPEND MAGICS_EXTRA_LIBRARIES ${ZLIB_LIB} )
endif()

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

add_subdirectory( tools )
add_subdirectory( src )
add_subdirectory( share )
add_subdirectory( apps )
add_subdirectory( test )


if(NOT HAVE_EFAS)
  ecbuild_add_resources( TARGET noefas DONT_PACK_DIRS share/magics/efas)
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_resources
		DONT_PACK_DIRS
		docs
		toolsjs
		notebook)


############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/magics" )

### print all variables
#get_cmake_property(_variableNames VARIABLES)
#foreach (_variableName ${_variableNames})
#    ecbuild_info("${_variableName}=${${_variableName}}")
#endforeach()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
###############################################################################

configure_file( magics_config.h.in  magics_config.h  )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})

###############################################################################


function( add_metview_definition_file )

    set( single_value_args ACTION BASENAME FILE )
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

    add_custom_command(
            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
            DEPENDS ${_p_FILE}
      )


    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)

endfunction(add_metview_definition_file)



add_subdirectory( params )


foreach( file ${magics_xmls} )
      get_filename_component( path     ${file} PATH   )
      get_filename_component( basefile ${file} NAME_WE )

      set( ouputfiles ${CMAKE_CURRENT_SOURCE_DIR}/attributes/${basefile}Attributes.h ${CMAKE_CURRENT_SOURCE_DIR}/attributes/${basefile}Attributes.cc )
      list( APPEND magics_params_srcs ${ouputfiles} )
endforeach()


foreach( file ${metview_xmls} )
      get_filename_component( path     ${file} PATH   )
         get_filename_component( basefile ${file} NAME_WE )

      set( metviewfiles ${CMAKE_CURRENT_SOURCE_DIR}/attributes/${basefile}Wrapper.h ${CMAKE_CURRENT_SOURCE_DIR}/attributes/${basefile}Wrapper.cc )
      list( APPEND metview_wrappers_srcs ${metviewfiles} )
   endforeach()

   if(qt)
      SET(qt_drivers_HEADERS drivers/MgQ/MgQPlotScene.h)
      if( MAGICS_QT5 )
         QT5_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
      else()
         QT4_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
      endif()
      list( APPEND drivers_srcs  drivers/MgQ/MgQPlotScene.cc  ${qt_drivers_HEADERS_MOC})
   endif()



#add_custom_command( magics_params DEPENDS ${magics_params_srcs} ${metview_wrappers_srcs} )

###############################################################################

add_subdirectory( common )
add_subdirectory( basic )
add_subdirectory( web )
add_subdirectory( visualisers )
add_subdirectory( drivers )
add_subdirectory( decoders )
add_subdirectory( terralib )
add_subdirectory( clipper )
add_subdirectory( eckit_readers )

if( metview )
	add_subdirectory( libMagWrapper )
endif()

if( HAVE_ODB )
	add_subdirectory( oda )
  # Adding path to the Oda directory
  list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/oda> )
endif()

ecbuild_add_library( TARGET    MagPlus
                     SOURCES
                        magics.h
                        ${magics_params_srcs}
                        ${common_srcs}
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${clipper_srcs}
                        ${terralib_srcs}
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     PUBLIC_DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                     PUBLIC_LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                        eccodes
                     PRIVATE_INCLUDES $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/clipper>
                                      ${MAGICS_PRIVATE_INCLUDE_DIRS}

                     PUBLIC_INCLUDES $<INSTALL_INTERFACE:${PROJ_INCLUDE_DIRS}>
                                     $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/attributes>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/basic>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/common>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/drivers>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/decoders>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/visualisers>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/terralib/kernel>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/eckit_readers>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/web>
                                     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/drivers/MgQ>
                                     $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
                     TYPE SHARED )

target_link_libraries(MagPlus PRIVATE ${EXPAT_LIBRARIES} ${PROJ_LIBRARIES})

if(APPLE)
  target_link_libraries(MagPlus PRIVATE ${ZLIB_LIBRARIES})
endif(APPLE)

if(HAVE_CAIRO)
    target_link_libraries(MagPlus PRIVATE ${PANGOCAIRO_LIBRARIES})
endif()

if(HAVE_NETCDF)
    target_link_libraries(MagPlus PRIVATE NetCDF::NetCDF_C)
endif()

ecbuild_add_library( TARGET         MagPlusSingle
                     SOURCES        MagicsSingle.cc
                     PRIVATE_LIBS   MagPlus
                     TYPE           SHARED )

ecbuild_add_library( TARGET         MagPlusDouble
                     SOURCES        MagicsDouble.cc
                     PRIVATE_LIBS   MagPlus
                     TYPE           SHARED )

if( metview )

   ecbuild_add_library(	TARGET			MagWrapper
                     	SOURCES			magics.h
                        			${metview_srcs}
                        			${metview_wrappers_srcs}
                     	PUBLIC_DEFINITIONS	${MAGICS_EXTRA_DEFINITIONS}
                     	PUBLIC_LIBS		MagPlus
                        PRIVATE_INCLUDES ${MAGICS_PRIVATE_INCLUDE_DIRS}
                        PUBLIC_INCLUDES $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/libMagWrapper>
                     	TYPE			STATIC
                    )
   if(HAVE_CAIRO)
    target_link_libraries(MagWrapper PRIVATE ${PANGOCAIRO_LIBRARIES})
   endif()

   if(HAVE_NETCDF)
    target_link_libraries(MagWrapper PRIVATE NetCDF::NetCDF_C)
   endif()

   list( APPEND attributes_include
            OutputHandlerAttributes.h
            FortranRootSceneNodeAttributes.h
            BinningObjectAttributes.h
            GribDecoderAttributes.h
            DateGribLoopStepAttributes.h
            GribLoopAttributes.h
            GeoRectangularProjectionAttributes.h
            LegendVisitorAttributes.h
            XmlRootNodeAttributes.h
            WrepRootNodeAttributes.h
            ContinuousLegendMethodAttributes.h
            HistogramLegendMethodAttributes.h
            XmlBasicNodeAttributes.h
            LookupTableModeAttributes.h
            FixedTableModeAttributes.h
   )
   if(qt)
     list(APPEND attributes_include QtDriverAttributes.h)
   endif()

   install( FILES terralib/kernel/TeProjection.h
		  terralib/kernel/TeCoord2D.h
		  terralib/kernel/TeDefines.h
		  terralib/kernel/TePrecision.h
		  terralib/kernel/TeSingleton.h
		  terralib/kernel/TeDatum.h
		  terralib/kernel/TeUtils.h
		  DESTINATION ${INSTALL_INCLUDE_DIR})

   install( FILES AutoVector.h       DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES Iterable.h         DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES ReverseIterable.h  DESTINATION ${INSTALL_INCLUDE_DIR})

   foreach( file ${attributes_include} )
     install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/attributes/${file}  DESTINATION ${INSTALL_INCLUDE_DIR})
   endforeach()
   install( FILES ${metview_include} DESTINATION ${INSTALL_INCLUDE_DIR})
endif()


install( FILES magics.h                DESTINATION ${INSTALL_INCLUDE_DIR})
install( FILES common/magics_export.h  DESTINATION ${INSTALL_INCLUDE_DIR})
install( FILES common/magics_windef.h  DESTINATION ${INSTALL_INCLUDE_DIR})

## Add install include dirs to install interface
foreach( target     MagPlus
                    MagPlusStatic
                    MagPlusSingle
                    MagPlusSingleStatic
                    MagPlusDouble
                    MagPlusDoubleStatic
                    MagWrapper )
    if( TARGET ${target} AND DEFINED ecbuild_VERSION)
        target_include_directories( ${target} INTERFACE $<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}> )
    endif()
endforeach()

=== test/CMakeLists.txt ===
set( eccodes_environment
  ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}
  ECCODES_SAMPLES_PATH=${ECCODES_SAMPLES_PATH}
  )

# Basic test
ecbuild_add_test( TARGET          coast_c
                  SOURCES         coast.c
                  LIBS            MagPlusSingle MagPlus
                  ENVIRONMENT     MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE C )

ecbuild_add_test( TARGET          contour_c
                  SOURCES         contour.c
                  CONDITION       HAVE_GRIB
                  RESOURCES       data.grib
                  LIBS            MagPlusSingle MagPlus
                  ENVIRONMENT     MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                                   ${eccodes_environment}
                  LINKER_LANGUAGE C )

ecbuild_add_test( TARGET          netcdf_c
                  SOURCES         netcdf.c
                  CONDITION       HAVE_NETCDF
                  RESOURCES       era5_2mt.nc
                  LIBS            MagPlusSingle MagPlus
                  ENVIRONMENT     MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE C )

=== debian/changelog ===
magics++ (4.5.0-2) unstable; urgency=medium

  * Fix cmake paths

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 22 Oct 2020 07:29:37 +0100

magics++ (4.5.0-1) unstable; urgency=medium

  * New usptream release
  * Move Vcs-Git to point to debian/latest branch
  * Update d/gpb.conf to show use of DEP-14 branches
  * Enable EFAS coastlines, Disable ODB (deprecated)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Oct 2020 15:57:59 +0100

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat  (= 13) , 
 ecbuild (>= 3.3.0-3),
 gfortran | fortran-compiler, 
 python3-all-dev,
 libhdf5-dev | libhdf5-mpi-dev, 
 libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libodb-api-dev (>= 0.18.1-11),
 libeccodes-dev (>= 2.13.0-3),
 libeccodes-tools,
 libemos-bin, 
 libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 fonts-dejavu-core, 
 libxml-parser-perl, 
 ghostscript, 
 zlib1g-dev, 
 libboost-dev | libboost1.63-dev, 
 libproj-dev, 
 qtbase5-dev-tools, 
 qtbase5-dev, 
 qt5-qmake,
 python3-jinja2
Standards-Version: 4.5.0
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Browser: https://salsa.debian.org/science-team/magics.git
Vcs-Git: https://salsa.debian.org/science-team/magics.git -b debian/latest

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core, fonts-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, 
 python3, libmagics++-metview-dev, libterralib-dev, magics++, libodb-api-dev
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, python3
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.


Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) -DACCEPT_USE_OF_DEPRECATED_PROJ_API_H # -std=c++14
CFLAGS:= -fPIC $(shell dpkg-buildflags --get CFLAGS) -DACCEPT_USE_OF_DEPRECATED_PROJ_API_H=1 
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

export QT_SELECT=5

LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
CMAKEDIR:=debian/tmp/$(LIBDIR)/cmake/magics

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with-buildsystem=ecbuild

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DENABLE_ODC=0 \
	-DENABLE_EFAS=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_THREADS=1 \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_C_FLAGS='$(CFLAGS) ' \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	# remove Makefile: it attempts a Docker build from git ...
	rm -f Makefile
	rm -rf debian/build-py* build/*x
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	find . -name '.DS_Store' -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build src/boost

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	dh_auto_install 
	# sed -i -e 's%$${_IMPORT_PREFIX}/${LIBDIR}%${LIBDIR}%g' $(CMAKEDIR)/magics-targets-none.cmake
	#sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(CMAKEDIR)/magics-targets-none.cmake
	sed -i -e 's%${CURDIR}%/build/magics++%g'       $(CMAKEDIR)/magics-config.cmake 
	sed -i -e 's%${CURDIR}%/build/magics++%g'       $(CMAKEDIR)/magics-import.cmake 
	#sed -i -e 's%$${_IMPORT_PREFIX}/include/magics%/usr/include/magics%g' $(CMAKEDIR)/magics-targets.cmake
	sed -i -e 's%$${CURDIR}%/build/magics++%g' $(CMAKEDIR)/magics-import.cmake 
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_makeshlibs:
	# For new symbols when compiled with GCC 7
	dh_makeshlibs -V'libmagplus3v5 (>= 2.34.1-2~)'

## magics++ 4.5.1

=== debian/changelog ===
magics++ (4.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Nov 2020 18:09:11 +0000

magics++ (4.5.0-3) unstable; urgency=medium

  * Drop dependencies on odb-api (not used anymore)
  * Re-enable ODB, using libodc-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Nov 2020 19:15:51 +0000

## magics++ 4.5.2

=== debian/changelog ===
magics++ (4.5.2-2) unstable; urgency=medium

  * Fix serious typo in d/control. Closes: #977354

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Dec 2020 14:55:21 +0000

magics++ (4.5.2-1) unstable; urgency=medium

  * New upstream release
  * Move default boost include to 1.74
  * Standards-Version: 4.5.1; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 13 Dec 2020 12:52:34 +0000

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,10 @@
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  libgl1-mesa-dev, libgd-dev, 
  libemos-dev (>=  2:4.3.9), libgeotiff-dev,
- libodb-api-dev (>= 0.18.1-11),
  libeccodes-dev (>= 2.13.0-3),
  libeccodes-tools,
+ libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
+ odc [!powerpc !armel !armhf !i386 !mipsel],
  libemos-bin, 
  libopenjp2-7-dev,
  libaec-dev,
@@ -23,13 +24,13 @@
  libxml-parser-perl, 
  ghostscript, 
  zlib1g-dev, 
- libboost-dev | libboost1.63-dev, 
+ libboost-dev | libboost1.74-dev, 
  libproj-dev, 
  qtbase5-dev-tools, 
  qtbase5-dev, 
  qt5-qmake,
  python3-jinja2
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
 Vcs-Browser: https://salsa.debian.org/science-team/magics.git
 Vcs-Git: https://salsa.debian.org/science-team/magics.git -b debian/latest
@@ -61,8 +62,10 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, 
- python3, libmagics++-metview-dev, libterralib-dev, magics++, libodb-api-dev
+Depends: libmagplus3v5 ( = ${binary:Version} ), 
+ ${misc:Depends}, ${ecbuild:Depends}
+ python3, libmagics++-metview-dev, libterralib-dev, magics++,
+ libodc-dev [!powerpc !armel !armhf !i386 !mipsel]
 Recommends: pkg-config
 Description: Development files for ECMWF  plotting software MAGICS++
  Magics++ is the latest generation of the ECMWF's Meteorological plotting
@@ -78,7 +81,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: libmagplus3v5 ( = ${binary:Version} ),
- ${misc:Depends}, ${shlibs:Depends}, python3
+ ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}, python3
 Description: Executables for the magics++ library
  Magics++ is the latest generation of the ECMWF's Meteorological plotting
  software MAGICS. Although completely redesigned in C++, it is intended to be

## magics++ 4.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-project( magics VERSION 4.5.0 LANGUAGES CXX )
+project( magics VERSION 4.5.3 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()
@@ -246,6 +246,7 @@
 ecbuild_add_resources( TARGET old_resources
 		DONT_PACK_DIRS
 		docs
+		regression
 		toolsjs
 		notebook)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,25 +5,6 @@
 install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})
 
 ###############################################################################
-
-
-function( add_metview_definition_file )
-
-    set( single_value_args ACTION BASENAME FILE )
-    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )
-
-    add_custom_command(
-            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
-            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
-            DEPENDS ${_p_FILE}
-      )
-
-
-    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
-    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)
-
-endfunction(add_metview_definition_file)
-
 
 
 add_subdirectory( params )

=== apps/MagMLInterpretor/CMakeLists.txt ===
configure_file( magjson-script.in  magjson @ONLY )
configure_file( magml-script.in    magml   @ONLY )

install(FILES		${CMAKE_CURRENT_BINARY_DIR}/magjson
	DESTINATION	${INSTALL_BIN_DIR}
	PERMISSIONS	OWNER_READ GROUP_READ WORLD_READ
			OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

install(FILES		${CMAKE_CURRENT_BINARY_DIR}/magml
	DESTINATION	${INSTALL_BIN_DIR}
	PERMISSIONS	OWNER_READ GROUP_READ WORLD_READ
			OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

ecbuild_add_executable(
		TARGET		magjsonx
		SOURCES		json.cc
		DEFINITIONS	${MAGICS_EXTRA_DEFINITIONS}
		LIBS		MagPlus ${MAGICS_EXTRA_LIBRARIES}
		)

ecbuild_add_executable(
		TARGET		magmlx
                SOURCES		magml.cc
                DEFINITIONS	${MAGICS_EXTRA_DEFINITIONS}
		LIBS		MagPlus ${MAGICS_EXTRA_LIBRARIES}
		)

=== src/common/CMakeLists.txt ===
list( APPEND _common_srcs

	OutputFactory.h MagLog.h
	BaseParameter.h Colour.h MagException.h
	Factory.cc Factory.h
	ParameterManager.h Frame.h Layout.h
	PaperPoint.h GeoPoint.h  Tokenizer.h Node.h MagTranslator.h
	ImageProperties.h LogoPlotting.h
	ImportObject.h ColourTable.h PageID.h
	Transformation.h Dimension.h
	XmlNode.h XmlTree.h XmlReader.h BackgroundColour.h
	ColourTableDefinition.h ColourTableDefinitionCompute.h ColourTableDefinitionComputeInterface.h
	ColourTableDefinitionList.h ColourTableDefinitionListInterface.h
	TableDefinition.h TableDefinitionList.h TableDefinitionListInterface.h
	TableDefinitionCompute.h TableDefinitionComputeInterface.h
	HeightTableDefinition.h LevelTableDefinition.h IntervalMap.h PaperDimension.h
	Matrix.h MatrixHandler.h Data.h MagicsDecoder.h
	BasePointsHandler.h RasterData.h  Visualiser.h CustomisedPoint.h PointsHandler.h
	MetaData.h
	Polyline.h
	Text.h
	Symbol.h
	BinaryObject.h
	Arrow.h
	Flag.h
	Image.h
	ArrowProperties.h
	MagicsParameter.cc MagicsParameter.h Clipper.h LogoPlottingBase.h
	TableDefinitionCompute.cc
	TableDefinitionList.cc
	Coordinate.h OutputHandler.h
	MagFont.h
	AnimationRules.h SymbolItem.h
	UserPoint.h Label.h
	Timer.h
	CustomisedPoint.h Static.h DriverStatic.h ProgressObject.h PolyCoast.h
	ProgressTask.h FullPaperPoint.h
	BasePointsHandler.h PointsHandler.h MagicsDecoder.h Data.h
	Visualiser.h MatrixHandler.h
	Seconds.h
	Matrix.h Matrix.cc
	Path.h
	MagicsSingleton.h
	PlotManager.h
	Image.h
	MagClipper.h
	XmlReader.h XmlTree.h XmlNode.h
	MagicsFormat.h
	CartesianTransformation.h
	Dimension.cc
	XCoordinate.h YCoordinate.h marsmachine.h linux.h aix.h
	Thread.h MutexCond.h Mutex.h AutoLock.h ThreadControler.h Task.h MagExceptions.h ThreadSingleton.h
	DataStats.h SciMethods.h Tephigram.cc  Tephigram.h Skewt.cc  Skewt.h Emagram.cc Emagram.h

# sources
	Data.cc Matrix.cc MagicsCalls.cc Static.cc DriverStatic.cc MagLog.cc Colour.cc Transformation.cc MagException.cc
	BaseParameter.cc ParameterManager.cc
	Tokenizer.cc Timer.cc Seconds.cc Label.cc MagClipper.cc
	ArrowProperties.cc
	XmlReader.cc XmlTree.cc XmlNode.cc Dimension.cc
	MetaData.cc
	MagicsFormat.cc
	OutputHandler.cc  OutputFactory.cc
	MagFont.cc
	ColourTable.cc ColourTableDefinitionList.cc
	ColourTableDefinitionCompute.cc CartesianTransformation.cc
	BinaryObject.cc
	Coordinate.cc
	LogoPlotting.cc
	PageID.cc AnimationRules.cc Layout.cc SymbolItem.cc Symbol.cc Polyline.cc
	Text.cc Flag.cc
	Mutex.cc MutexCond.cc Thread.cc MagExceptions.cc AutoLocker.cc
	ThreadControler.cc Task.cc
	DataStats.cc SciMethods.cc BasePointsHandler.cc PointsHandler.cc ProgressObject.cc

# projection
	GeoRectangularProjection.cc  PolarStereographicProjection.cc TaylorProjection.cc
	GeoRectangularProjection.h   PolarStereographicProjection.h TaylorProjection.h
	Proj4Projection.cc  Proj4Projection.h ProjP.cc ProjP.h

# stuff from eckit

	# Value.cc Value.h

	JSONParser.cc JSONParser.h
	ObjectParser.cc ObjectParser.h
	Translator.cc Translator.h
	StreamParser.cc StreamParser.h
	JSON.cc JSON.h
	Value.cc Value.h
	MapContent.cc MapContent.h
		OrderedMapContent.cc OrderedMapContent.h

	NilContent.cc NilContent.h
	StringContent.cc StringContent.h
	BoolContent.cc BoolContent.h
	ListContent.cc ListContent.h
	DoubleContent.cc DoubleContent.h
	NumberContent.cc NumberContent.h
	Content.cc Content.h
	Counted.cc Counted.h
 )

if( EC_OS_NAME MATCHES "windows" )
	list( APPEND _common_srcs win_time.h win_time.cc magics_windows.h magics_windows.cc )
endif()

list( APPEND _common_templates
    Factory.cc
    MagicsParameter.cc
    TableDefinitionList.cc
    TableDefinitionCompute.cc
 )

foreach( file ${_common_srcs} )
  list( APPEND common_srcs common/${file} )
endforeach()
foreach( file ${_common_templates} )
  list( APPEND common_templates common/${file} )
endforeach()

set( common_srcs ${common_srcs} PARENT_SCOPE )
set( common_templates ${common_templates} PARENT_SCOPE )

if ( metview )
	list (APPEND metview_include
				common/MagLog.h
				common/MagTranslator.h
				common/Factory.h
				common/Factory.cc
				common/Colour.h
				common/Tokenizer.h
				common/MagException.h
				common/ParameterManager.h
				common/PaperPoint.h
				common/Matrix.h
				common/BaseParameter.h
				common/OutputHandler.h
				common/OutputFactory.h
				common/Layout.h
				common/XmlNode.h
				common/Transformation.h
				common/UserPoint.h
				common/CustomisedPoint.h
				common/XmlTree.h
				common/XmlReader.h
				common/RasterData.h
				common/MagicsDecoder.h
				common/Data.h
				common/MatrixHandler.h
				common/BasePointsHandler.h
				common/Timer.h
				common/DataStats.h
				common/IntervalMap.h
				common/GeoRectangularProjection.h
				common/Text.h
				common/Label.h
				common/MagFont.h
				common/Image.h
				common/ImageProperties.h
				common/ColourTable.h
				common/ColourTableDefinition.h
				common/PointsHandler.h
				common/ProjP.h
				)

	if ( EC_OS_NAME MATCHES "windows" )
		list (APPEND metview_include common/win_timer.h)
	endif()

	set( metview_include ${metview_include} PARENT_SCOPE )
endif()
install ( FILES magics_api.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== src/web/CMakeLists.txt ===
set( _web_srcs
MagJSon.cc   ObsJSon.cc   WrepJSon.h
MagConfig.cc    MagJSon.h    ObsJSon.h
MagConfig.h     WrepJSon.cc
GeoJSon.h GeoJSon.cc

 )

foreach( file ${_web_srcs} )
  list( APPEND web_srcs web/${file} )
endforeach()

set( web_srcs ${web_srcs} PARENT_SCOPE )

=== debian/changelog ===
magics++ (4.5.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Jan 2021 12:39:40 +0000

=== debian/control ===
--- 
+++ 
@@ -63,7 +63,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: libmagplus3v5 ( = ${binary:Version} ), 
- ${misc:Depends}, ${ecbuild:Depends}
+ ${misc:Depends}, ${ecbuild:Depends},
  python3, libmagics++-metview-dev, libterralib-dev, magics++,
  libodc-dev [!powerpc !armel !armhf !i386 !mipsel]
 Recommends: pkg-config

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 export DH_VERBOSE=1
+
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 # To enable all, uncomment following line
 # DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
@@ -17,6 +20,10 @@
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
 CMAKEDIR:=debian/tmp/$(LIBDIR)/cmake/magics
 
+# Fixes for 32-bit archss
+ARCH_32BIT:=   i386 armel armhf mipsel hppa hurd-i386 m68k powerpc sh4 x32
+DO_ODB:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_32BIT)),OFF,ON)
+
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
@@ -27,7 +34,7 @@
 	-DBUILD_SITE=debian \
 	-DENABLE_LIBGD=1 \
 	-DHAVE_BOOST=1 \
-	-DENABLE_ODC=0 \
+	-DENABLE_ODB=$(DO_ODB) \
 	-DENABLE_EFAS=1 \
 	-DHAVE_DLFCN_H=1 \
 	-DHAVE_INTTYPES_H=1 \
@@ -63,7 +70,6 @@
 	-DENABLE_TESTS=ON \
 	-DENABLE_GEOTIFF=ON \
 	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
-	-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
 	-DENABLE_RPATHS=OFF \
 	-DENABLE_CAIRO=ON \
 	-DENABLE_BUFR=ON \

## magics++ 4.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-project( magics VERSION 4.5.3 LANGUAGES CXX )
+project( magics VERSION 4.6.0 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()
@@ -37,6 +37,11 @@
                     DEFAULT ON
                     DESCRIPTION "cairo support[png/jpeg]"
                     REQUIRED_PACKAGES PangoCairo)
+
+ecbuild_add_option( FEATURE DOCUMENTATION
+                    DEFAULT OFF
+                    DESCRIPTION "Adding support for automatic documentation"
+                  )
 
 
 string(STRIP "${PANGOCAIRO_LIBRARIES}" PANGOCAIRO_LIBRARIES)
@@ -235,6 +240,9 @@
 add_subdirectory( share )
 add_subdirectory( apps )
 add_subdirectory( test )
+if( HAVE_DOCUMENTATION )
+  add_subdirectory( docs )
+endif()
 
 
 if(NOT HAVE_EFAS)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -52,6 +52,9 @@
 add_subdirectory( terralib )
 add_subdirectory( clipper )
 add_subdirectory( eckit_readers )
+
+list( APPEND MAGICS_DOCS common)
+list( APPEND MAGICS_DOCS basic)
 
 if( metview )
 	add_subdirectory( libMagWrapper )

=== debian/changelog ===
magics++ (4.6.0-2) unstable; urgency=medium

  * Rebuild against odc 1.3.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 28 Mar 2021 16:17:35 +0100

magics++ (4.6.0-1) unstable; urgency=medium

  * New upstream release
  * Fix FTFBFS with g++ 11.  Closes: #984233

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Mar 2021 14:08:08 +0000
